package com.jdbernard.wdiwtlt.db.models;

import java.util.UUID;
import javax.persistence.Entity;

@Entity
public class Model implements Comparable<Model>, Cloneable {
    public UUID id;

    public boolean equals(Object thatObj) {
        if (thatObj == null) return false;
        if (this.getClass() != thatObj.getClass()) return false;

        Model that = (Model) thatObj;

        if (this.id == null || that.id == null) return false;
        return this.id.equals(that.id); }

    public int compareTo(Model that) {
        if (this.id == null) return -1;
        if (this.getClass() != that.getClass()) {
            return this.getClass().getSimpleName().compareTo(
                that.getClass().getSimpleName()); }

        return this.id.compareTo(that.id); }
}
